import ProjectDescription

let name: Template.Attribute = .required("name")
let example: Template.Attribute = .optional("example", default: "false")
let platform: Template.Attribute = .optional("platform", default: "iOS")

let template = Template(
    description: "Module",
    attributes: [
        name,
        example,
        platform,
    ],
    items: [
        .file(path: "Projects/\(name)/Project.swift", templatePath: "project.stencil"),
        .file(path: "Projects/\(name)/Sources/\(name).swift", templatePath: "sources.stencil"),
        .file(path: "Projects/\(name)/Tests/\(name)Tests.swift", templatePath: "tests.stencil"),
        .string(path: "Projects/\(name)/Resources/ReplaceMe", contents: "ReplaceMe"),
        .file(path: "Projects/\(name)/Example/Sources/AppDelegate.swift", templatePath: "example_main.stencil"),
        .file(path: "Projects/\(name)/Example/Sources/ViewController.swift", templatePath: "example_view.stencil"),
        .string(path: "Projects/\(name)/Example/Resources/ReplaceMe", contents: "ReplaceMe"),
    ]
)
